/****************************************************************/
/* A Simple JDBC Program (Section 5.2)                          */
/* Chapter 5; Oracle Programming -- A Primer                    */
/*            by R. Sunderraman                                 */
/****************************************************************/

import java.sql.*; 
import java.io.*; 

class UpdateMajor { 
  public static void main (String args []) 
      throws SQLException, IOException { 

    DriverManager.registerDriver (new oracle.jdbc.driver.OracleDriver());

    String user, pass, sql, studentID, newMajor;
    user = readEntry("userid  : ");
    pass = readEntry("password: ");
    Connection conn =  DriverManager.getConnection
                            ("jdbc:oracle:oci8:@yuetest", user, pass);

    Statement stmt = conn.createStatement (); 

    System.out.println("The available majors are: \n");

    sql = "select MAJOR from H3_Majors";    

    ResultSet rset = stmt.executeQuery (sql);

    while (rset.next ()) { 
       System.out.println(rset.getString(1));
    } 

    System.out.print("\n");

    studentID = readEntry("Enter the student ID to update major => ");

    sql = "select SFIRSTNAME, SLASTNAME, SMAJOR from H3_Students where StudentID = " + studentID;

    rset = stmt.executeQuery (sql);
    rset.next();
    System.out.println(rset.getString("SFirstName") + "  " +
                       rset.getString("SLastName") + " is currently majoring in  " +
                       rset.getString("SMajor") + "\n");

    newMajor = readEntry("New Major => ");

    sql = "update H3_Students set SMajor ='" + newMajor + "' where StudentID = " + studentID;

    try {
       stmt.executeUpdate(sql);
    } catch (SQLException e) {
      System.out.println("Could not change major.");
      return;
    }
    System.out.println("Major changed!");

    conn.close();
  } 

  //readEntry function -- to read input string
  static String readEntry(String prompt) {
     try {
       StringBuffer buffer = new StringBuffer();
       System.out.print(prompt);
       System.out.flush();
       int c = System.in.read();
       while(c != '\n' && c != -1) {
         buffer.append((char)c);
         c = System.in.read();
       }
       return buffer.toString().trim();
     } catch (IOException e) {
       return "";
       }
   }
} 
